# changes made from the default rendering of racket markdown

code blocks have syntax highlighting baked by pygments. additionally, tex-style math expressions are
baked to mathml using mathjax-node (this requires a polyfill on google chrome, which is filled in by
nginx)

# extensions provided on top of regular racket markdown

## front matter

front matter is an s-expr

example

```
((date 2021 06 06)
 (slug "meow")
 (title "meow!")
 (summary "the summary")
 (tags "WaterDrinkers" "drinking" "water")
 (authors "haskal"))

regular markdown content here
```

front matter is required. if you have no front matter to provide, use an empty list:

```
()

page content here
```

## hashtags

a hashtag `#hashtag` appearing anywhere except in code and math blocks will be converted to a
hashtag link which leads to an aggregate of all pages that use that tag (in the `tags` metadata)

## xrefs

pages go into a hierarchy based on their folders and the declared `slug` metadata (or slug derived
from markdown filename - except for `index.md` which becomes the index in a certain folder).
xrefs are a way to refer to slugs. xref can appear in links as follows

```
[some link](^some/page/xref)
```

## user links

user pages can be linked to either with a freestanding mention or a link

```
@haskal

[link to haskal](@haskal)
```

## tech terms

like scribble docs, technical terms can be defined and referenced. currently you need to stem
manually using the `key` attribute

```
<deftech key="florp">florps</deftech> are like stars, but shaped like a floppy disk

...

i <tech key="florp">florped</tech> the post
```

## masto

uwu

```
<masto>https://cybre.space/@haskal/106372557156109664</masto>
```
